/*
 * local defs of useful things
 */

#ifndef __FS_USERFS_USERFS_H_SEEN__
#define __FS_USERFS_USERFS_H_SEEN__

#if __cplusplus
#define __FUNCTION__	"__FUNCTION__:"__FILE__":(function/line unknown)"
#endif

#define MIN(a,b) (((a) < (b)) ? (a) : (b))
#define MAX(a,b) (((a) > (b)) ? (a) : (b))

extern struct file_operations userfs_file_operations;
extern struct inode_operations userfs_inode_operations;
extern struct super_operations userfs_super_operations;

extern void userfs_close_chan(struct super_block *);
extern void userfs_setcred(up_cred *);

extern struct super_operations *userfs_probe_sops(struct super_block *);
extern struct inode_operations *userfs_probe_iops(struct super_block *);
extern struct file_operations *userfs_probe_fops(struct super_block *);

extern int userfs_probe(struct super_block *, up_ops);

/* A kiss to end a sleep */
extern struct pwlist *userfs_kiss(struct super_block *, int seq, int why);

/* reasons why */
#define UP_FINISH	1	/* Finish up - your prince will never come */
#define UP_RECV		2	/* Your prince has arrived */
#define UP_BATON	3	/* You take over */

/* for matching entries */
#define UP_WFIRST	-1	/* wake first */
#define UP_WALL		-2	/* wake all entries */

/* Element on list of sleeping processes */
struct pwlist
{
	struct wait_queue *bed;		/* where we sleep */
	int	why;			/* filled on wake - why we woke */
	int	seq;			/* reply seqence */
	upp_repl repl;			/* reply header */
	char	*more;			/* extra data */
	int	pid;			/* prince id */

	struct pwlist *next;		/* there are other beauties */
	struct pwlist *prev;
};

#endif /* __FS_USERFS_USERFS_H_SEEN__ */
