// -*- c++ -*-
// Inode management class
// This is a very Q&D conversion from C.  It could do with some
// designing and proper use of inheritance.

#include <sys/types.h>

class itab;

typedef unsigned long hand_t;

class ient
{
    	friend itab;

	char *elem;		// Name of this file
	ient *dir;		// Directory it's in
	hand_t handle;		// Handle of file (inode number)
	int fd;			// fd, if opened
	ient *next;		// Links in list
	ient *prev;
	int used;		// If dir, # of files in it
	unsigned opened;	// # times this file is open
	int unlinked;

	itab *table;

	ient(const char *, hand_t, ient *, ient *, itab *);
	~ient();

	void insert(ient *);
	void remove();

public:
	char *catname(char *buf);
	hand_t gethand()		{ return handle; }

	int open();
	int isopen()			{ return opened; }
	void close();
	int lstat(struct stat *);
	int stat(struct stat *);
	int rename(ient *ndir, const char *name);

	unsigned long goo;
};

class itab
{
	ient *list;
	int inodes;

 public:
	itab()				{ list = NULL; inodes = 1; }

	hand_t genhand(dev_t d, ino_t i)	{ return d<<16 | i; }
	
	ient *map_inode(const char *, hand_t, ient *);
	ient *get_inode(hand_t);

	int unlink(ient *);
	void use(ient *ent);
};
		
