// -*- c++ -*-
//
// C++ classes for making user level filesystems easier
//
// This program is distributed under the terms of the
// Free Software Foundation General Public Licence.
// Copyright Jeremy Fitzhardinge 1993

#ifndef __FILESYSTEM_H_SEEN__
#define __FILESYSTEM_H_SEEN__

#include <errno.h>

extern "C" {
#include <linux/userfs_fs.h>
#include <linux/userfs_types.h>
}

typedef unsigned char Data;

class Filesystem
{
	int tokern, fromkern;
	int fssend(const Data *data, size_t size);
	int fsrecv(Data *data, size_t size);

	int getreq(up_preamble &, Data *&);
	
	char *mpoint;

#define P(o)	int fs_##o(int enq, upp_repl &repl, Data *data)
	P(mount);
	P(umount);
	P(iread);
	P(iwrite);
	P(iput);
	P(statfs);
#undef P

public:
	Filesystem(int to, int from);
	Filesystem(const char *mpoint);
	virtual ~Filesystem();

	int FromFd()	{ return fromkern; }
	int ToFd()	{ return tokern; }

	int DoOp();
};

#endif	// __FILESYSTEM_H_SEEN__
